import React from "react";
import { useState, useEffect } from "react";
import style from "./App.module.css";
import useWebSocket, { ReadyState } from 'react-use-websocket';

export default function App() {
    const { sendMessage, lastMessage, readyState } = useWebSocket('ws://localhost:8080');

    const [hash, setHash] = useState('');
    const [minLength, setMinLength] = useState(1);
    const [maxLength, setMaxLength] = useState(8);
    const [workers, setWorkers] = useState(2);

    useEffect(() => {
        if (lastMessage !== null) {
            console.log('New message', lastMessage);
        }
    }, [lastMessage]);

    useEffect(() => {
        if (readyState === ReadyState.OPEN) {
            console.log('Connection opened');
            sendMessage('client');
        }
    }, [readyState]);

    return (
        <div className={style.inputs}>
            {/* Create inputs for Hash, min and max length, number of workers and a button */}
            <div>
                <label htmlFor="hash">Hash</label>
                <input type="text" id="hash" placeholder="Hash" value={hash} onChange={
                    (e) => {
                        setHash(e.target.value);
                    }
                }/>
            </div>
            <div>
                <label htmlFor="minLength">Min length</label>
                <input type="number" id="minLength" placeholder="Min length" value={minLength} onChange={
                    (e) => {
                        setMinLength(parseInt(e.target.value));
                    }
                } />
            </div>
            <div>
                <label htmlFor="maxLength">Max length</label>
                <input type="number" id="maxLength" placeholder="Max length" value={maxLength} onChange={
                    (e) => {
                        setMaxLength(parseInt(e.target.value));
                    }
                } />
            </div>
            <div>
                <label htmlFor="workers">Number of workers</label>
                <input type="number" id="workers" placeholder="Number of workers" value={workers} onChange={
                    (e) => {
                        setWorkers(parseInt(e.target.value));
                    }
                } />
            </div>
            <button onClick={sendHash}>Start</button>
        </div>
    );

    function sendHash() {
        sendMessage(`${hash}:${minLength}:${maxLength}:${workers}`)
    }
}